<template>
  <!-- Radio group wrapper -->
  <div :class="getElementCssClass('wrapper')">
    <RadioInput
      v-for="(option, key) in options"
      :key="key"
      v-model="vModel"
      :name="name"
      :value="getValueAttribute(option)"
      :required="required"
      :variant="variant"
    >
      <!-- Default slot -->
      <template #default="defaultSlotProps">
        <!--
          @slot Default slot
          @binding {Object} v-bind - Dynamically bind default slot-scope from `RadioInput` component
          @binding {any} option - The original option
        -->
        <slot
          name="default"
          v-bind="{
            ...defaultSlotProps,
            option: option
          }"
        />
      </template>
    </RadioInput>
  </div>
</template>

<script>
// Mixins
import Variantable from '#mixins/variantable/'
import VModelable from '#mixins/v-modelable/'

/**
 * RadioGroup component
 */
export default {
  name: 'RadioGroup',
  mixins: [
    VModelable,
    Variantable
  ],
  props: {
    /**
     * Input name
     */
    name: {
      type: String,
      required: true
    },
    /**
     * If the radio input is required
     */
    required: {
      type: Boolean,
      default: false
    },
    /**
     * The options
     */
    options: {
      type: Array,
      required: true
    },
    /**
     * Value attribute to get from option object for input value
     * Can be a function that takes option item as unique parameter (function (item): any) and returns the value
     * Default: "value"
     */
    valueAttribute: {
      type: [ String, Function ],
      default: 'value'
    }
  },
  methods: {
    getValueAttribute (obj) {
      return typeof this.valueAttribute === 'function'
        ? this.valueAttribute(obj)
        : obj[this.valueAttribute]
    }
  },
  // Variantable options
  style: {
    /* eslint quote-props: ["error", "consistent"] */
    fixedClasses: {
      wrapper: {
        'flex': true,
        'flex-col': true,
        'gap-2': true,
        'm-1': true
      }
    },
    classes: {
      wrapper: {}
    },
    variants: {}
  }
}
</script>

<style lang="scss">
// Do logic
</style>
